doctype html
html
	title N1QL Browser for Teams
	script(src="/external/jquery.min.js")
	script(src="/external/bootstrap.min.js")
	script(src="https://unpkg.com/babel-standalone@6/babel.min.js")
	link(rel="stylesheet" href="https://bootswatch.com/yeti/bootstrap.min.css")
	link(rel="stylesheet" href="/external/css/font-awesome.min.css")
	link(rel="stylesheet" href="/resources/css/style.css")
	script(src="/external/vue.min.js")
	script(src="/external/lodash.min.js")
body
	div#app
		nav.navbar.navbar-default
			div.container-fluid
				div.navbar-header
					a.navbar-brand(href="/") N1QL for teams
				div.collapse.navbar-collapse
					ul.nav.navbar-nav.navbar-right
						li
							a(href="/about.html") Version: 0.5.0
		div.container.editor(v-if="mainModule=='query'")
			div.alert.alert-info.page-status(v-if="appstatus.length>0")
				span {{ appstatus }}
			div.row.query-editor
				div.col-md-12
					div
						span.wide 
							a(href="#" v-on:click="showStats=!showStats") Show stats: {{ showStats | niceBoolean }}
						span.wide
							a(href="#" v-on:click="saveQueries=!saveQueries") Save Queries: {{ saveQueries | niceBoolean }}
						span.wide
							a(href="#" v-on:click="showEditorTools=!showEditorTools") Toolbar: {{ showEditorTools | niceBoolean }}
					input.form-control.query(type="text" placeholder="Enter a N1QL query" v-model="query" v-on:keyup="filterHistory")
					span.spaced
						button.btn.btn-primary(v-on:click="execute") Execute &nbsp;
							i.fa.fa-bolt
					div(v-if="filteredHistory.length>0 && saveQueries")
						div.text-info
							strong From your history
						ul.query-history
							li(v-for="q in filteredHistory")
								a(href="#" v-on:click="query = q.q") {{ q.q }}
								span.history.text-success(v-if="q.status=='Success'")  Status: {{ q.status }}
								span.history(v-if="q.status=='Success'")  Response Time {{ q.code | toMs }} ms
								span.history.text-danger(v-if="q.status!='Success'")  Status: {{ q.status }}
								span.history(v-if="q.status!='Success'")  Code {{ q.code }}
			div.row.stats(v-if="showStats==true").top-spaced
				div.col-md-4
					p.text-info Query Time
					div.stats Latency: {{ stats.latency }} ms
					div.stats Query time: {{ stats.executionTime | toMs }} ms
					div.stats Total time: {{ stats.totalTime }} ms
				div.col-md-4
					p.text-info Query Response
					div.stats Items: {{ stats.resultCount | localize }}
					div.stats Total size: {{ stats.resultSize | toKb }} kb
					div.stats Avg. per Item: {{ stats.averageitem | toKb }} kb
				div.col-md-4
					p.text-info Others
					div.stats
						a(href="#" v-on:click="displayExplain=!displayExplain") Indexes used: {{ stats.indexesUsed }}
					div.stats Query: &nbsp;
						span.code(v-html="format(query)")
			div.row.result.top-spaced
				div.col-md-12(v-if="displayExplain==false")
					div(v-if="showEditorTools")
						div.btn-group(role="group" aria-label="...")
							button.btn.btn-default(type="button" v-on:click="toggleDisplayMode") Table/JSON
							button.btn.btn-default(type="button" v-on:click="discoverSchema") Schema&nbsp;
								i.fa.fa-code
							button.btn.btn-default(type="button" v-on:click="buildMap()")
								i.fa.fa-globe
							button.btn.btn-default(type="button" v-on:click="fontSize('up')")
								i.fa.fa-font +
							button.btn.btn-default(type="button" v-on:click="fontSize('down')")
								i.fa.fa-font -
					div(v-if="displayMode=='json'")
						textarea.n1ql(rows=30 placeholder="Results will be shown here" readonly) {{ results }}
					div(v-if="displayMode=='schema'")
						h3 Schema
							div
								table.table
									tr
										th Field
										th Type
										th Mandatory
										th Parent
									tr(v-for="k in schema")
										td {{ k.name }}
										td {{ k.type }}
										td
											i.fa.fa-check(v-if="k.isMandatory==true")
										td
											span(v-if="k.fpath!==''") {{ k.fpath }}.
											span {{ k.parent }}
					div(v-if="displayMode=='map'")
						div(v-if="results!=''")
							div Please define the fields that contain map coordinates
							div
								input(type="text" placeholder="Lat. Example: geolocation.lat" v-model="geolat")
								input(type="text" placeholder="Lon. Example: geolocation.lon" v-model="geolon")
								span
								button.btn.btn-primary(v-on:click="mapResults()") Search
							div#map
						div(v-if="results==''")
							h4 Execute a query to search for coordinates
					div(v-if="displayMode=='table'")
						table.table.table-bordered
							tr
								th(v-for="h in resultsHeaders") {{ h }}
							tr(v-for="r in resultsJson")
								td(v-for="item in r" v-html="tablefy(item)")
				div.col-md-12(v-if="displayExplain")
					textarea.n1ql(rows=30 placeholder="Results will be shown here" readonly) {{ explainPlan }}
		div.container.server-info(v-if="mainModule==''")
			div.row
				div.alert.alert-info.page-status(v-if="appstatus.length>0")
						span {{ appstatus }}
				div.col-md-6
					h3 Select a server
					form.form
						label Server:
						select.form-control.server(v-on:change="connect")
							option(v-for="s in servers") {{ s.name }}
						label Or enter an IP/Host name
						input.form-control(type="text" placeholder="i.e. couchbase.test.com")
						button.btn.btn-primary(v-on:click="connect") Connect
				div.col-md-6
					h3 Buckets
					div(v-if="server==null")
						span Pick a server to get the list of available buckets.
					div(v-if="server!=null")
						table.table.table-condensed
							tr
								th Bucket
								th Quota (Mb)
								th Replicas
								th Actions
							tr(v-for="b in buckets")
								td 
									i.fa.fa-database &nbsp;
									span {{ b.Name }}
								td.center {{ b.Quota | toMb }}
								td.center {{ b.Replicas }}
								td
									a(href="#" v-on:click="openEditor(b.Name)" title="Query Engine")
										i.fa.fa-arrow-circle-right(aria-hidden="true")
									span &nbsp;
									a(href="#" v-on:click="openClassicView(b.Name)" title="Browse Documents")
										i.fa.fa-database
		div.container.docbrowser(v-if="mainModule=='documentbrowser'")
			h3.text-primary Bucket: {{ bucket }}
			h4.text-info Total results: {{ browser.total | localize }}
			div
				button.btn.btn-primary(v-if="browser.currentPage>0" v-on:click="queryBrowser(browser.currentPage-1)") <
				span  Page
				span.clickable.text-primary(v-on:click="browser.editPage = true" v-if="browser.editPage==false")  {{ browser.currentPage | localize }}
				input#curPage(v-on:keypress="updateCurrentPage" v-bind:value="browser.currentPage" v-if="browser.editPage==true")
				span  of {{ browser.totalPages | localize }} &nbsp;
				button.btn.btn-primary(v-if="browser.currentPage<browser.totalPages" v-on:click="queryBrowser(browser.currentPage+1)") >
			div.top-spaced.center(v-if="browser.results.length==0")
				i.fa.fa-spinner.fa-spin.fa-3x.fa-fw
			div(v-if="browser.selectedItem !== null")
				h5.text-info {{ browser.selectedItem.id }}
				textarea.n1ql(rows=30 placeholder="Results will be shown here" readonly) {{ browser.selectedItem.item }}
				div
					button.btn.btn-primary(v-on:click="browser.selectedItem=null") Close
			table.table.top-spaced(v-if="browser.results.length>0 && browser.selectedItem === null")
				tr
					th ID
					th Document
				tr(v-for="r in browser.results")
					td.clickable.text-primary(v-on:click="displayDocument(r.id, r.item)") {{ r.id }}
					td.documentJson.code {{ r.item }}
	script(src="resources/js/api.js")
	script(src="resources/js/app.js")
	script(src="resources/js/jsonutils.js")
	script(src="https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false")